image: node:latest

stages:
  - npm
  - lint
  - test

npm:
  stage: npm
  script:
    - npm config set registry ${CI_NPM_REGISTRY}
    - npm install
  cache:
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 days
    when: on_success
    paths:
      - node_modules/

lint:
  stage: lint
  dependencies:
    - npm
  script:
    - npm run lint

test:
  stage: test
  dependencies:
    - npm
  script:
    - npm test